#property copyright     "Author: laplacianlab, CC Attribution-Noncommercial-No Derivate 3.0"
#property link          "http://www.mql5.com/en/forum/ea"
#property version       "1.00"
#property description   "This is a basic trading system which consists in buying when MACD crosses above the waterline line and selling when crosses below it. This EA works along with a monetary management system which has a positive mathematical expectation."

#include <Trade\Trade.mqh>

//+------------------------------------------------------------------+
//| Input block                                                      |
//+------------------------------------------------------------------+

// General inputs

input string pair = "EURUSD";                      // und Andere
input ENUM_TIMEFRAMES timeframe = PERIOD_M1;       // automatisch

// MACD inputs

input int fastEMAPeriod = 13;                      // Fast EMA period
input int slowEMAPeriod = 26;                      // Slow EMA period
input int signalPeriod  = 9;                       // Difference period

// Monetary management strategy inputs

input double size       = 0.1;                     // The size of the operation
input int stufe         = 30;                      // zwischen dem Nachkauf
 
//+------------------------------------------------------------------+
//| Var block                                                        |
//+------------------------------------------------------------------+

int MACDHandle;
double MACDValues[];
string flag;         // 'flag' is 'buy' when we want the robot to buy and 'sell' when we want it to sell. 
int takeProfit;
int flagab; 
int flagauf;

int OnInit()
  {      
   SymbolSelect(pair, true);    
   MACDHandle = iMACD(Symbol(), timeframe, fastEMAPeriod, slowEMAPeriod, signalPeriod, PRICE_CLOSE);   
//AV: You have to check your MACDHandle to see if it's a valid handle (http://www.mql5.com/en/docs/indicators/imacd)  
   ArraySetAsSeries(MACDValues, true);   
//   flag = "buy";
   
   return(0);   
  }
  
void OnDeinit(const int reason)
  {
   IndicatorRelease(MACDHandle);
   ArrayFree(MACDValues);
  }

void OnTick()
  {    
   CTrade trade; 
   MqlTick tick;
   double sl = 0;
   double tp = 0;
   double flag1 = 0;
   double flag2 = 0;
//AV: Do not use cryptic variable name, what is ab1, ab2...auf1, auf2... ?
   double ab1 = 0; double ab2 = 0; double ab3 = 0; double ab4 = 0; double ab5 = 0;
   double auf1 = 0; double auf2 = 0; double auf3 = 0; double auf4 = 0; double auf5 = 0; 
   double Lots = 0;
    
   SymbolInfoTick(_Symbol, tick);
         
   if(CopyBuffer(MACDHandle, 1, 0, 2, MACDValues) > 0) 
   { 

//     {   
//       double sl = tick.ask + stopLoss * _Point;     ??????
//       double tp = tick.bid - takeProfit * _Point;   ??????
//     }

//AV: MACDValues[0] is value of current bar, always changing (each tick)
//AV: It's better to use MACDValues[1] and MACDValues[2]

//-------------------Short kaufen--------------------------------------      
      if (MACDValues[0] < MACDValues[1] && flag1 == 0)          //AV: flag1 is always =0 and is unnecessary
       {
         {                            
         if (flag1 == 0 && Lots == 0)                           //AV: always true
          {
          trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, size, tick.bid, sl, tp);
          Lots = Lots+size;
          ab1 = tick.bid - stufe * _Point;
          }
          
         if (flag1 == 0 && Lots > 0)                            //AV: always true
          {            
          ab2 = tick.bid - stufe * _Point;
          ab3 = ab2 - stufe * _Point;
          ab4 = ab3 - stufe * _Point;
          ab5 = ab4 - stufe * _Point;
          }
                 
          flag1= 0;
          flagauf = 1;    //fr Martin short
          return;
          return;       //AV: not need to return twice ;-)
        }
                   
        if (flagab == 1 && ab1 > tick.bid - stufe * _Point)         //AV: always false, flagab is not initialized, never =1
         {    
          trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, size, tick.bid, sl, tp);
          Lots = Lots+size;
          flagab = 2;
         } 
        
        if (flagab == 2 && ab2 > tick.bid - stufe * _Point)         //AV: always false : ab2 = tick.bid - stufe * _Point
         { 
          trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, size, tick.bid, sl, tp);
          Lots = Lots+size;
          flagab = 3;
         }
        
        if (flagab == 3 && ab3 > tick.bid - stufe * _Point)         //AV: always false, flagab unchanged 
         { 
          trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, size, tick.bid, sl, tp);
          Lots = Lots+size;
          flagab = 4;
         }
        
        if (flagab == 4 && ab4 > tick.bid - stufe * _Point)         //AV: always false, flagab unchanged 
         { 
          trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, size, tick.bid, sl, tp);
          Lots = Lots+size;
          flagab = 5;
         }
       }
     return;
// ----------------------------- Short glattstellen + 1 size drehen ------------         
       if (MACDValues[0] > MACDValues[1])       
        {
              if (flagab == 1)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lots+size, tick.ask, sl, tp);
                flagauf = 0;
                Lots = size;
               }  
              if (flagab == 2)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lots+size, tick.ask, sl, tp);
                flagauf = 0;
                Lots = size;
               }
              if (flagab == 3)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lots+size, tick.ask, sl, tp);
                flagauf = 0;
                Lots = size;
               } 
              if (flagab == 4)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lots+size, tick.ask, sl, tp);
                flagauf = 0;
                Lots = size;
               }
              if (flagab == 5)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, Lots+size, tick.ask, sl, tp);
                flagauf = 0;
                Lots = size;
               }
        }
      return;        
//------------------------------------Long kaufen-------------------------------------------         
       if (MACDValues[0] > MACDValues[1] && flag1 == 0) 
        {
         {                            
         if (flag1 == 0 && Lots == 0)  
          {
          trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, size, tick.bid, sl, tp);
          Lots = Lots+size;
          auf1 = tick.ask + stufe * _Point;
          }

         if (flag1 == 0 && Lots > 0)
          {            
          auf2 = tick.ask + stufe * _Point;
          auf3 = auf2 + stufe * _Point;
          auf4 = auf3 + stufe * _Point;
          auf5 = auf4 + stufe * _Point;
          }       
          flag1= 0;
          flagauf = 1;    //fr Martin short
          return;
          return;
        }                  
        if (flagauf == 1 && auf1 < tick.ask + stufe * _Point)         
         {
          trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, size, tick.ask, sl, tp);
          Lots = Lots+size;
          flagauf = 2;
         }   
        if (flagauf == 2 && auf2 < tick.ask + stufe * _Point)         
         {
          trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, size, tick.ask, sl, tp);
          Lots = Lots+size;
          flagauf = 3;
         }
        if (flagauf == 3 && auf3 < tick.ask + stufe * _Point)          
         {
          trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, size, tick.ask, sl, tp);
          Lots = Lots+size;
          flagauf = 4;
         }
        if (flagauf == 4 && auf4 < tick.ask + stufe * _Point)         
         {
          trade.PositionOpen(_Symbol, ORDER_TYPE_BUY, size, tick.ask, sl, tp);
          Lots = Lots+size;
          flagauf = 5;
         }                  
        }
      return;
//--------------------------------Long glatt stellen------------------  
       if (MACDValues[0] < MACDValues[1])
        {       
              if (flagauf == 1)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lots+size, tick.bid, sl, tp);
                flagab = 0;
                Lots = size;
               }  
              if (flagauf == 2)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lots+size, tick.bid, sl, tp);
                flagab = 0;
                Lots = size;
               }
              if (flagauf == 3)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lots+size, tick.bid, sl, tp);
                flagab = 0;
                Lots = size;
               } 
              if (flagauf == 4)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lots+size, tick.bid, sl, tp);
                flagab = 0;
                Lots = size;
               }
              if (flagauf == 5)
               {
                trade.PositionOpen(_Symbol, ORDER_TYPE_SELL, Lots+size, tick.bid, sl, tp);
                flagab = 0;
                Lots = size;
               }
        }
       return;
   }
  }